;--------------------------------------------------------------------------
;
;	Translate Cluster to first sector number in cluster using the formula
;
;	Sector = (Cluster - 2) * SectorsPerCluster + FirstDataSector
;
;	Input:
;	Y	Pointer to datastructure with P_Cluster set
;	Output:
;		P_Sector set to first sector in cluster
;	Registers:
;	r0, r1, r16, r17, r18, r19, r20
;
;******	20220-05-13	New register usage, list of caller:
;******			BuildFragList		ok
;******			OpenDir			ok
;******			ReadDir			ok
;******			ReadFileByte		ok
;******			ReadFileOpen		ok
;******
Cluster2Sector:
	ldd	r16, Y+P_Cluster+0
	ldd	r17, Y+P_Cluster+1
	ldd	r18, Y+P_Cluster+2
	ldd	r19, Y+P_Cluster+3
	ldi	r20, 2			; The first cluster is 2!
	sub	r16, r20
	sbc	r17, zero
	sbc	r18, zero
	sbc	r19, zero
	push	r19			; pcluster-2 bits24:31
	push	r18			; pcluster-2 bits16:23
	push	r17			; pcluster-2 bits8:15
	push	r16			; pcluster-2 bits0:7
	lds	r20, sectperclst
	lds	r16, datastart+0
	lds	r17, datastart+1
	lds	r18, datastart+2
	lds	r19, datastart+3
	pop	r0			; pcluster-2 bits0:7
	mul	r0, r20
	add	r16, r0
	adc	r17, r1
	adc	r18, zero
	adc	r19, zero
	pop	r0			; pcluster-2 bits8:15
	mul	r0, r20
	add	r17, r0
	adc	r18, r1
	adc	r19, zero
	pop	r0			; pcluster-2 bits16:23
	mul	r0, r20
	add	r18, r0
	adc	r19, r1
	pop	r0			; pcluster-2 bits24:31
	mul	r0, r20
	add	r19, r0
	std	Y+P_Sector+0, r16
	std	Y+P_Sector+1, r17
	std	Y+P_Sector+2, r18
	std	Y+P_Sector+3, r19
	ret 
