;==========================================================================
;	
;	For debugging purposes and clean-up the original FAT library
;	has been split into individual files, one for each sub-routine.
;
;	FAT Library
;
;		OpenDir
;
;		ReadDir
;
;		CopyName
;
;		MatchFileName
;
;		LinkedCluster
;
;		Cluster2Sector
;
;		BuildFragList
;
;		Logical2Physical
;
;		Name2DirEntry
;
;		CreatePath		v1-3	2019-01-06
;
;		ReadFileOpen		2019-12-16	Add first file IO primitives
;
;		ReadFileClose
;
;		ReadFileByte
;
;
;--------------------------------------------------------------------------
;
;	File Name Primitives
;
;	To deal with names we actually have three buffers. 
;
;	Long File Name Buffer is part of the parameter block and a pointer
;		to the buffer is stored in offset P_LongFileN of the parameter
;		block. This buffer is used by ReadDir() to accumulate the
;		parts of a long file name, the long file name is normally
;		initialised with 0x00.
;	Input Buffer is the buffer that contains the user input and which
;		is used as the source and used to skip device name, find the
;		next directory name or the filename, the input buffer is normally
;		terminated by a carriage return
;	Name Buffer is the buffer that will have the file or directory
;		name copied from the input buffer, the name buffer string
;		is null terminated
;
;	Filenames on FAT16 and FAT32 volumes can be up to 255 characters, so 
;	in theory all three name buffers must be long enough to hold the worst
;	possible scenario. However this wastes space. Therefore the buffersize
;	reserverd for these three buffers will be made configurable. At the
;	Moment 256 bytes are allocated for each.
;
.include "FAT-library/CopyName.asm"
.include "FAT-library/CreatePath.asm"
.include "FAT-library/Logical2Physical.asm"
.include "FAT-library/MatchFileName.asm"
.include "FAT-library/Cluster2Sector.asm"
.include "FAT-library/LinkedCluster.asm"
.include "FAT-library/BuildFragList.asm"
.include "FAT-library/FreeList.asm"
.include "FAT-library/OpenDir.asm"
.include "FAT-library/ReadDir.asm"
.include "FAT-library/Name2DirEntry.asm"
;--------------------------------------------------------------------------
;
;	File IO Primitives
;	
;--------------------------------------------------------------------------
.include "FAT-library/ReadFileOpen.asm"
.include "FAT-library/ReadFileClose.asm"
.include "FAT-library/ReadFileByte.asm"
