;--------------------------------------------------------------------------
;
;	Open Directory
;
;	Input:
;	Y	pointer to datastrcucture with P_Cluster set to the first cluster
;		of the sub-directory or 0 to read the root directory
;
;	Registers:
;	r16, r17
;
;	Completioncode:
;	CS
;	CC
;
;******	20220-05-??	New register usage, list of caller:
;******			Name2DirEntry		ok
;******			cmddir			ok
;******
;******

OpenDir:
	sec				; Assume error
	lds	r17, VolStatus
	sbrs	r17, MBRok
	ret				; MBR not ok -> error
	sbrs	r17, VBRok
	ret				; VBR not ok -> error	
	
	ldd	r16, Y+P_Cluster+0
	ldd	r17, Y+P_Cluster+1
	or	r16, r17
	ldd	r17, Y+P_Cluster+2
	or	r16, r17
	ldd	r17, Y+P_Cluster+3
	or	r16, r17
	brne	OpenDirCluster

	lds	r17, VolStatus		; We need to open the root dir
	sbrs	r17, FAT32
	rjmp	OpenRootDir16		; Special Case FAT16
	lds	r17, rootdir+0		; for FAT32 just copy the start
	std	Y+P_Cluster+0, r17	; cluster of the root dir
	lds	r17, rootdir+1
	std	Y+P_Cluster+1, r17
	lds	r17, rootdir+2
	std	Y+P_Cluster+2, r17
	lds	r17, rootdir+3
	std	Y+P_Cluster+3, r17
OpenDirCluster:
	rcall	Cluster2Sector
	ldi	r17, 1<<D_linked
	std	Y+P_Flag, r17		; Directory is linked list
	lds	r17, sectperclst	; Number of Sectors in Cluster
	rjmp	OpenDirAll
OpenRootDir16:
	lds	r17, rootdir+0		; Calculate first sector of root
	std	Y+P_Sector+0, r17	; directory
	lds	r17, rootdir+1
	std	Y+P_Sector+1, r17
	lds	r17, rootdir+2
	std	Y+P_Sector+2, r17
	lds	r17, rootdir+3
	std	Y+P_Sector+3, r17
	std	Y+P_Flag, zero		; Directory is one block of sectors
	lds	r17, dirsectors	; Number of Sectors in Root Directory	
OpenDirAll:	
	std	Y+P_NumSect, r17	; Number of sectors
	ldi	r17, 0xff
	std	Y+P_Count, r17		; Directory entries processed
	ldi	r17, low(pdirbuffer)
	std	Y+P_Address+0, r17
	ldi	r17, high(pdirbuffer)
	std	Y+P_Address+1, r17
	ldi	r17, led_time
	sts	led_oneshot, r17
	sbi	b_LED
	call	SD_CARD_READ		; Get first sector
	ret 
