;==========================================================================
;
;	Various routines, first built to support the file commands but later
;	all show and logging commands have been added. This module also 
;	includes the command parsing table. 
;
;	Needs to be split into modules, 2019-12-16 partially done 
;	Needs to be check for register usage!!!
;
;
;--------------------------------------------------------------------------
;
;	Variables
;
	.dseg
cdstring:	.byte	4
nbr:		.byte	4
pattern:	.byte	2
dmalimit:	.byte	1
attunit:	.byte	1
attpart:	.byte	1
tpflags:	.byte	1
.equ		tp__no	= 0

dirswitch:	.byte	1
.equ		dirswitch_a	= 0

dumpswitch:	.byte	1
.equ		dumpswitch_r	= 0
.equ		dumpswitch_c	= 1
.equ		dumpswitch_b	= 2
.equ		dumpswitch_h	= 3

dumpunit:	.byte	1
dumpblock:	.byte	4
dmapdp11:	.byte	3
rlv12init:	.byte	1

rdchkaddr:	.byte	3
rdchkblock:	.byte	2
rdchksize:	.byte	2
	.cseg
;==========================================================================
;
;	Local Subroutines
;
;--------------------------------------------------------------------------
;
; Print Directory Entry Information
;
printdirentry:
	push	zl
	push	zh

;	cli				;;;
;	lds	zl, log_pointer+0	;;; Logging
;	lds	zh, log_pointer+1	;;; Logging
;	movw	r25:r24, zh:zl		;;;
;	lognxt	r24, r25		;;; next logging buffer address
;	sei				;;;
;
;	ldi	r17, 1
;	std	Z+0, r17
;	ldi	r17, log_trace
;	std	Z+1, r17
;	ldi	r17, 0
;	std	Z+2, r17
;	ldd	r17, Y+P_Flag			
;	std	Z+3, r17
;	ldd	r17, Y+P_DirPointer+0
;	std	Z+4, r17
;	ldd	r17, Y+P_DirPointer+1
;	std	Z+5, r17

	ldd	zl, Y+P_LongFileN+0	; Get the long file name buffer pinter
	ldd	zh, Y+P_LongFileN+1
	ldd	r17, Y+P_Flag			
	sbrc	r17, D_Long		; 
	ld	r16, Z			; First character of long file name
	ldd	zl, Y+P_DirPointer+0
	ldd	zh, Y+P_DirPointer+1
	sbrs	r17, D_Long
	ldd	r16, Z+D_Name		; First character of short file name
	cpi	r16, '.'		; Hidden dot-file?
	brne	printdirentry010	; no print it
	lds	r16, dirswitch
	sbrs	r16, dirswitch_a
	rjmp	printdirentry140	; -a not set don't print it
printdirentry010:
	ldd	r17, Z+D_Attr		; Attributes
	sbrs	r17, A_Hidden		; Is the file hidden
	rjmp	printdirentry020	; no, print it
	lds	r16, dirswitch		; get dir switches
	sbrs	r16, dirswitch_a
	rjmp	printdirentry140	; -a not set don't print it
printdirentry020:
	ldd	r16, Z+D_Attr		; Attributes
	ldi	r17, 'A'		
	sbrs	r16, A_Archive		; Archived
	ldi	r17, ' '
	sts	pprint+0, r17
	ldi	r17, 'S'
	sbrs	r16, A_System		; System
	ldi	r17, ' '
	sts	pprint+1, r17
	ldi	r17, 'H'
	sbrs	r16, A_Hidden		; Hidden
	ldi	r17, ' '
	sts	pprint+2, r17
	ldi	r17, 'R'
	sbrs	r16, A_Readonly	; Read-only
	ldi	r17, ' '
	sts	pprint+3, r17

	ldd	r16, Z+D_Cluster+0
	ldd	r17, Z+D_Cluster+1
	sts	pprint+4, r16
	sts	pprint+5, r17		; Lower 16-bit of Startcluster

	lds	r16, VolStatus
	sbrs	r16, FAT32
	rjmp	printdirentry030	; In case of FAT32 we also have
	ldd	r16, Z+D_ClusterH+0	; Higher 16-bit of Startcluster
	ldd	r17, Z+D_ClusterH+1
	sts	pprint+6, r16
	sts	pprint+7, r17
	call	print
	.db	CR, LF, 0x90, 0x91, 0x92, 0x93, " C:", 0x87, 0x86, 0x85, 0x84, " ", 0, 0
	rjmp	printdirentry040

printdirentry030:
	call	print
	.db	CR, LF, 0x90, 0x91, 0x92, 0x93, " C:", 0x85, 0x84, " ", 0, 0
	
printdirentry040:
	ldd	r16, Z+D_Attr		; Attributes
	sbrc	r16, A_Volume
	rjmp	printdirentry050
	sbrs	r16, A_Directory
	rjmp	printdirentry060
	call	print
	.db	" <DIR>       ", 0	; It's a directory
	rjmp	printdirentry070

printdirentry050:	
	call	print
	.db	" <Volume>    ", 0	; It's the volume information (Name)
	rjmp	printdirentry070
printdirentry060:	
	ldd	r16, Z+D_Size+0	; Get file length in bytes
	sts	pprint+0, r16
	ldd	r16, Z+D_Size+1
	sts	pprint+1, r16
	ldd	r16, Z+D_Size+2
	sts	pprint+2, r16
	ldd	r16, Z+D_Size+3
	sts	pprint+3, r16
	call	print
	.db	0xD0, 0			; Print size in decimal with thousand separator

printdirentry070:	
	ldi	r24, ' '				
	call	serout
;+
	ldd	r16, Y+P_Flag			
	sbrc	r16, D_Long
	rjmp	printdirentry120	; Only print short name if there is no long name
;-
	ldi	r18, 8		; Print short file name
	clr	r16			; Number of characters printed so far
printdirentry080:
	ld	r24, Z+
	cpi	r24, ' '
	breq	printdirentry090
	call	serout
	inc	r16
	dec	r18
	brne	printdirentry080
printdirentry090:
	ldd	zl, Y+P_DirPointer+0
	ldd	zh, Y+P_DirPointer+1
	adiw	Z, 8
	ld	r24, Z
	cpi	r24, ' '		; Does file have extension?
	breq	printdirentry110	; no then dont show anything
	ldi	r24, '.'		; dot between name and exteions
	inc	r16
	call	serout
	ldi	r18, 3
printdirentry100:
	ld	r24, Z+
	cpi	r24, ' '
	breq	printdirentry110
	call	serout
	inc	r16
	dec	r18
	brne	printdirentry100
printdirentry110:
	cpi	r16, 13		; Did we already print 13 characters?
	breq	printdirentry120	; then done
	ldi	r24, ' '		; Else make sure we printed 13 characters
	call	serout			; to have the long file names all starting
	inc	r16			; at the same screen position
	rjmp	printdirentry110

printdirentry120:
	ldd	r16, Y+P_Flag
	sbrs	r16, D_Long		; Does the file have a long file name?
	rjmp	printdirentry140	; nope
	ldd	zl, Y+P_LongFileN+0	; Get the long file name buffer pinter
	ldd	zh, Y+P_LongFileN+1
	std	Z+36, zero		; just for safety reasons max 36 characters
printdirentry130:			; Print long file name
	ld	r24, Z+
	tst	r24
	breq	printdirentry140
	call	serout
	rjmp	printdirentry130
printdirentry140:
	pop	zh
	pop	zl
	ret
;--------------------------------------------------------------------------
;
;	Subroutine that checks unitnumber and if unit is free
;
;	Input
;
;	attunit		The unit number
;
;	Output
;
;	CC		Unit valid and not attached
;	CS		Unit is invalid or already attached
;	Z		Pointer to the Unit Control Block
;
;	Registers
;
;	r16
;
checkunit:
	lds	zl, attunit
	cpi	zl, units
	brlo	checkunit010
	ori	zl, '0'
	sts	pprint+0, r16
	call	print
	.db	"Unit ", 0x90, " does not exist", CR, LF, 0
	sec
	ret

checkunit010:
	swap	zl
	clr	zh
	subi	zl, low(-unittable)
	sbci	zh, high(-unittable)

	ldd	r16, Z+ucb_status
	andi	r16, (1<<ucb__part) | (1<<ucb__file)
	breq	checkunit020
	lds	r16, attunit
	ori	r16, '0'
	sts	pprint+0, r16
	call	print
	.db	"Unit ", 0x90, " is busy ", CR, LF, 0
	sec
	ret
checkunit020:
	clc
	ret
;--------------------------------------------------------------------------
;
;
;
showlinked:
	push	yl
	push	yh
	rcall	checkvolume
	brcc	showlinked010
	rcall	novolume
	rjmp	showlinkedexit

showlinked010:
	ldi	yl, low(pcluster)
	ldi	yh, high(pcluster)
	lds	r16, nbr+0
	lds	r17, nbr+1
	lds	r18, nbr+2
	lds	r19, nbr+3
	std	Y+P_Cluster+0, r16
	std	Y+P_Cluster+1, r17
	std	Y+P_Cluster+2, r18
	std	Y+P_Cluster+3, r19
	sts	pprint+0, r16
	sts	pprint+1, r17
	sts	pprint+2, r18
	sts	pprint+3, r19
	call	LinkedCluster
	brne	showlinked020
	call	print
	.db	CR, LF, "Cluster 0x", 0x83, 0x82, 0x81, 0x80, " is last in list.", CR, LF, 0
	rjmp	showlinkedexit
showlinked020:
	ldd	r16, Y+P_Cluster+0
	ldd	r17, Y+P_Cluster+1
	ldd	r18, Y+P_Cluster+2
	ldd	r19, Y+P_Cluster+3
	sts	pprint+4, r16
	sts	pprint+5, r17
	sts	pprint+6, r18
	sts	pprint+7, r19
	call	print
	.db	CR, LF, "Linked Cluster Returned 0x", 0x88, " Cluster 0x"
	.db	0x83, 0x82, 0x81, 0x80, "-->0x", 0x87, 0x86, 0x85, 0x84, CR, LF, 0
showlinkedexit:
	clc
	pop	yh
	pop	yl
	ret
;--------------------------------------------------------------------------
;
;	find partition
;
;	Input
;
;	attpar		number of partition to find
;
;	Output
;
;	CS		partition not found
;	CC		partition found
;	Y		pointer to partition control block
;
;	Registers
;
;	<none>
;
findpart:
	push	zl
	push	zh
	ldi	zl, low(pcbqueue)	; get partition queue head
	ldi	zh, high(pcbqueue)
findpart010:
	ldd	yl, Z+0			; get partition
	ldd	yh, Z+1
	cp	yl, zero		; end of list
	cpc	yh, zero
	breq	findpart090		; yes then done
	ldd	zl, Y+pcb_id		; get id
	lds	zh, attpart
	cp	zl, zh
	breq	findpart020
	movw	Z, Y
	rjmp	findpart010
;
findpart020:
	pop	zh
	pop	zl
	clc
	ret

findpart090:
	pop	zh
	pop	zl
	sec
	ret

;--------------------------------------------------------------------------
;
;	Y		pointer to file control block
;
printfraglist:
	push	xl
	push	xh
	push	zl
	push	zh
	call	print
	.db	"  Fragments of file", CR, LF, 0
	movw	zl:zh, yl:yh
	adiw	Z, fcb_fraglist
	
printfraglist010:
	ldd	xl, Z+0			; get next fragment descriptor
	ldd	xh, Z+1
	sbiw	xh:xl, 0		; did we get one
	breq	printfraglist020	; nope, end of descriptor reached
	movw	zh:zl, xh:xl		; copy descriptor pointer
	ldd	xl, Z+Fr_Size+0		; copy information to print parameter
	sts	pprint+0, xl
	ldd	xl, Z+Fr_Size+1
	sts	pprint+1, xl
	ldd	xl, Z+Fr_Size+2
	sts	pprint+2, xl
	ldd	xl, Z+Fr_Size+3
	sts	pprint+3, xl
	ldd	xl, Z+Fr_Start+0
	sts	pprint+4, xl
	ldd	xl, Z+Fr_Start+1
	sts	pprint+5, xl
	ldd	xl, Z+Fr_Start+2
	sts	pprint+6, xl
	ldd	xl, Z+Fr_Start+3
	sts	pprint+7, xl
	call	print
	.db	"   Size:", 0x83, 0x82, 0x81, 0x80, " Start:", 0x87, 0x86, 0x85, 0x84, CR, LF, 0
	rjmp	printfraglist010

printfraglist020:
	pop	zh
	pop	zl
	pop	xh
	pop	xl
	ret
;==========================================================================
;
;	Command Routines
;
;--------------------------------------------------------------------------
;
;	Change Directory
;
;	-	in case there is a string save the start address and size
;	-	when the command was parsed successfully check for a string
;	-	if no string we reset active directory to root directory
;	-	if there is a string terminate it with 0x00
;	-	Call OpenDir
;	-	Call ReadDir		CS -> not found
;	-	Call MatchEntry		CS -> try next directory entry
;		-	If not a directory then issue message
;		-	If saved "r24" is \ start with copy name
;		-	If saved "r24" is 0x00 we are done
;
;	Commands to implement
;
;	How to maintain the working directory name
;
;	1.	Initially the working directory is set to the root, that is the
;		start cluster is 0 and the path is empty
;
;	2.	When executing a CD command we need to first check if the path
;		defined is valid
;
;	3.	If the path is valid we do not change the working directory
;
;	4.	A path change to '..' will go down the path only if we are not
;		at the root, else it will be ignored
;
;	New
;
;	5.	Absolute paths
;

;--------------------------------------------------------------------------
;
;	CD command
;
cmdcd:
	push	yl
	push	yh
	rcall	checkvolume
	brcc	cmdcd005
	rcall	novolume
	rjmp	cmdcdexit

cmdcd005:
	ldi	yl, low(pdircluster)
	ldi	yh, high(pdircluster)
	lds	xl, cdstring+2
	lds	xh, cdstring+3
	st	X, zero			; Zero Terminate the string
	lds	xl, cdstring+0
	lds	xh, cdstring+1
	rcall	startclustersave

	rcall	chkrootdir
	breq	cmdcd010
	call	Name2DirEntry
	brcs	cmdcdfnf
	ldd	zl, Y+P_DirPointer+0	; Directory found
	ldd	zh, Y+P_DirPointer+1
	ldd	r16, Z+D_Attr     
	sbrs	r16, A_Directory
	rjmp	cmdcdnad		; this is not a directory

	lds	xl, cdstring+0
	lds	xh, cdstring+1
	ldi	zl, low(Path)
	ldi	zh, high(Path)
	call	CreatePath
	clc
	rjmp	cmdcdexit
cmdcd010:
	sts	Path, zero
	clc
	rjmp	cmdcdexit

cmdcdfnf:
	call	print
	.db	"CD - directory not found", CR, LF, 0, 0

	rcall	startclusterrest

	clc
	rjmp	cmdcdexit
cmdcdnad:
	call	print
	.db	"CD - not a directory", CR, LF, 0, 0

	rcall	startclusterrest

	clc
	rjmp	cmdcdexit

cmdcdexit:
	pop	yh
	pop	yl
	ret
;--------------------------------------------------------------------------
;
;	dir <directory>
;
cmddirdir:
	push	yl
	push	yh
	rcall	checkvolume
	brcc	cmddir010
	rcall	novolume
	rjmp	cmddirexit
cmddir010:
	ldi	yl, low(pdircluster)	; use general directory
	ldi	yh, high(pdircluster)
	lds	xl, cdstring+2
	lds	xh, cdstring+3
	st	X, zero			; Zero Terminate the string
	lds	xl, cdstring+0
	lds	xh, cdstring+1
	rcall	startclustersave
	rcall	chkrootdir
	breq	cmddir050
	call	Name2DirEntry
	brcc	cmddir030
	call	print
	.db	"DIR - directory not found", CR, LF, 0
	rcall	startclusterrest
	rjmp	cmddirexit
cmddir030:
	ldd	zl, Y+P_DirPointer+0
	ldd	zh, Y+P_DirPointer+1
	ldd	r16, Z+D_Attr
	sbrc	r16, A_Directory
	rjmp	cmddir040
	call	print
	.db	"DIR - not a directory", CR, LF, 0
	rcall	startclusterrest
	rjmp	cmddirexit
;
;	Display Path
;
cmddir040:
	ldi	xl, low(Path)
	ldi	xh, high(Path)
	ldi	zl, low(plfilename)
	ldi	zh, high(plfilename)
cmddir050:
	ld	r16, X+
	st	Z+, r16
	tst	r16
	brne	cmddir050
	ldi	zl, low(plfilename)
	ldi	zh, high(plfilename)
	lds	xl, cdstring+0
	lds	xh, cdstring+1
	call	CreatePath
	ldi	yl, low(plfilename)
	ldi	yh, high(plfilename)
	rcall	cmddirall
	rcall	startclusterrest
	rjmp	cmddirexit
;
;	dir (current directory)
;
cmddir:
	push	yl
	push	yh
	rcall	checkvolume
	brcc	cmddir100
	rcall	novolume
	rjmp	cmddirexit
cmddir100:
	ldi	yl, low(Path)
	ldi	yh, high(Path)
	rcall	cmddirall
cmddirexit:
	clc
	pop	yh
	pop	yl
	ret
;
;
;
cmddirall:
	call	print
	.db	CR, LF, "Directory of /", 0, 0
cmddirall010:
	ld	r24, Y+
	tst	r24
	breq	cmddirall020
	call	serout
	rjmp	cmddirall010
cmddirall020:
	call	seroutcrlf
	ldi	yl, low(pdircluster)
	ldi	yh, high(pdircluster)
	ldi	r16, low(pdirbuffer)
	std	Y+P_Address+0, r16
	ldi	r16, high(pdirbuffer)
	std	Y+P_Address+1, r16
	ldi	r16, low(plfilename)
	std	Y+P_LongFileN+0, r16
	ldi	r16, high(plfilename)
	std	Y+P_LongFileN+1, r16
	ldd	r16, Y+P_StartClust+0
	std	Y+P_Cluster+0, r16
	ldd	r16, Y+P_StartClust+1
	std	Y+P_Cluster+1, r16
	ldd	r16, Y+P_StartClust+2
	std	Y+P_Cluster+2, r16
	ldd	r16, Y+P_StartClust+3
	std	Y+P_Cluster+3, r16
	call	OpenDir
cmddirallloop:
	call	ReadDir
	brcs	cmddiralldone
	rcall	printdirentry
	rjmp	cmddirallloop
cmddiralldone:
	call	seroutcrlf
	ret

;--------------------------------------------------------------------------
;
;	local subroutines - placed into the middle of the module
;	so we can always use rcall
;
.macro	mov32
	ldd	r16, @1+0
	ldd	r17, @1+1
	ldd	r18, @1+2
	ldd	r19, @1+3
	std	@0+0, r16
	std	@0+1, r17
	std	@0+2, r18
	std	@0+3, r19
.endmacro

startclustersave:
	mov32	Y+P_SaveClust, Y+P_StartClust
;	ldd	r16, Y+P_StartClust+0	; Save current start cluster
;	ldd	r17, Y+P_StartClust+1
;	ldd	r18, Y+P_StartClust+2
;	ldd	r19, Y+P_StartClust+3
;	std	Y+P_SaveClust+0, r16
;	std	Y+P_SaveClust+1, r17
;	std	Y+P_SaveClust+2, r18
;	std	Y+P_SaveClust+3, r19
	ret
;
startclusterrest:
	mov32	Y+P_StartClust, Y+P_SaveClust
;	ldd	r16, Y+P_SaveClust+0
;	ldd	r17, Y+P_SaveClust+1
;	ldd	r18, Y+P_SaveClust+2
;	ldd	r19, Y+P_SaveClust+3
;	std	Y+P_StartClust+0, r16
;	std	Y+P_StartClust+1, r17
;	std	Y+P_StartClust+2, r18
;	std	Y+P_StartClust+3, r19
	ret

;--------------------------------------------------------------------------
;
;	Y	pointer to file control block
;
novolume:
	call	print
	.db	"No Volume! ", CR, LF, 0
	clc
	ret
;
;
;
chkrootdir:
	ld	r16, X			; Get first character in 
	cpi	r16, DELIM		; Absolute path requested?
	brne	chkrootdir010		; NE no
	adiw	X, 1			; Skip
	std	Y+P_StartClust+0, zero
	std	Y+P_StartClust+1, zero
	std	Y+P_StartClust+2, zero
	std	Y+P_StartClust+3, zero
	ld	r16, X
	tst	r16			; EQ means path is only "/"
chkrootdir010:
	ret
;
;
;
checkvolume:
	clc
	lds	r16, VolStatus
	sbrs	r16, MBRok
	sec				; MBR not ok -> error
	sbrs	r16, VBRok
	sec				; VBR not ok -> error	
	ret
;--------------------------------------------------------------------------
;
;	
;
attachcmdnaf:
	call	print
	.db	"Not a file!", CR, LF, 0
	rcall	startclusterrest
	clc
	rjmp	attachcmdexit	
attachcmdfnf:
	call	print
	.db	"File not found!", CR, LF, 0
	rcall	startclusterrest
attachcmderr:
	clc
	rjmp	attachcmdexit
;--------------------------------------------------------------------------
;
;	attach <unit> <file>
;
attachcmd:
	push	xl
	push	xh
	push	yl
	push	yh
	rcall	checkvolume
	brcc	attachcmd001
	rcall	novolume
	rjmp	attachcmdexit
attachcmd001:
	rcall	checkunit
	brcs	attachcmderr
	
	ldi	yl, low(pdircluster)
	ldi	yh, high(pdircluster)
	lds	xl, cdstring+2
	lds	xh, cdstring+3
	st	X, zero			; Zero Terminate the string
	lds	xl, cdstring+0
	lds	xh, cdstring+1
	rcall	startclustersave
	
	rcall	chkrootdir
	breq	attachcmdfnf		; Just / as filename does not exist
	
	call	Name2DirEntry
	brcs	attachcmdfnf
	ldd	zl, Y+P_DirPointer+0
	ldd	zh, Y+P_DirPointer+1
	ldd	r16, Z+D_Attr
	sbrc	r16, A_Directory
	rjmp	attachcmdnaf

	rcall	startclusterrest
;
;	File Size must match one of the valid images
;
	ldi	r16, (1<<F_Image)	; Assume valid image
	push	r16
;
;	Using Parameter registers r22, r23, r24, r25
;
	ldd	r22, Z+D_Size+0
	tst	r22			; Must be multiple of 512
	brne	attachcmd002
	ldd	r22, Z+D_Size+1		; Convert file size
	sbrc	r22, 0			; Must be multiple of 512
	rjmp	attachcmd002
	ldd	r23, Z+D_Size+2
	ldd	r24, Z+D_Size+3
	clr	r25			; standard parameter register
	lsr	r24
	ror	r23
	ror	r22			; to number of blocks
	call	FindDrvEntry
	adiw	r25:r24, 0
	brne	attachcmd003
attachcmd002:	
	call	print
	.db	"not a valid disk image!", CR, LF, 0
	pop	r16
	push	zero			; clear flag

attachcmd003:
	movw	r23:r22, r25:r24	; Save Drive Table Entry
	ldi	r24, low(fcb_length)
	ldi	r25, high(fcb_length)
	call	malloc
	brcc	attachcmd005
	pop	r16			; dismiss flag
	call	print
	.db	"not enough memory for fcb!", CR, LF, 0, 0
	clc
	rjmp	attachcmdexit

attachcmd005:
	movw	yh:yl, r25:r24		; 
	std	Y+fcb_drvtab+0, r22	; Save drive tab entry returned by FindDrvEntry
	std	Y+fcb_drvtab+1, r23
	pop	r16
	std	Y+fcb_flag, r16	; Initialise the flags
;
;	Build full path file name. First we calculate the size of the
;	current path plus the file name size. We ignore that the file
;	name could have some changes to the parent folder but that's
;	ok as we only will allocate more bytes than required
;
	lds	xl, cdstring+0
	lds	xh, cdstring+1		; pointer to start of file name
	lds	r24, cdstring+2
	lds	r25, cdstring+3		; pointer to end of file name
	sub	r24, xl
	sbc	r25, xh			; Length of filename

	ld	r16, X
	cpi	r16, DELIM
	breq	attachcmd120		; We have an absolute path

	ldi	xl, low(Path)		; Get length of working directory path
	ldi	xh, high(Path)
attachcmd110:
	ld	r16, X+
	tst	r16
	breq	attachcmd120
	adiw	r25:r24, 1		; Add to filename
	rjmp	attachcmd110
;
;	r25:r24 contains now the total lenght of path and file
;
attachcmd120:
	adiw	r25:r24, 1		; for the zero termination
	call	malloc			;
	brcc	attachcmd130
	call	print
	.db	"not enough memory for file name!", CR, LF, 0, 0
	std	Y+fcb_filename+0, zero
	std	Y+fcb_filename+1, zero
	rjmp	attachcmd190
	
attachcmd130:
	push	zl
	push	zh			; Save Dir Pointer
	movw	xh:xl, r25:r24
	st	X, zero
	std	Y+fcb_filename+0, r24
	std	Y+fcb_filename+1, r25
	lds	zl, cdstring+0
	lds	zh, cdstring+1
	ld	r16, Z
	cpi	r16, DELIM
	breq	attachcmd150
	ldi	zl, low(Path)
	ldi	zh, high(Path)
attachcmd140:
	ld	r16, Z+		; Copy current working directory
	st	X+, r16
	tst	r16
	brne	attachcmd140
attachcmd150:
	lds	xl, cdstring+0
	lds	xh, cdstring+1
	movw	zh:zl, r25:r24
	call	CreatePath
	pop	zh			; Restore Dir Pointer
	pop	zl
attachcmd190:
;
;
;
	std	Y+fcb_cluster+3, zero
	std	Y+fcb_cluster+2, zero	; Assume FAT-16
	lds	r16, VolStatus
	sbrs	r16, FAT32
	rjmp	attachcmd010
	ldd	r16, Z+D_ClusterH+1	; no its FAT-32
	std	Y+fcb_cluster+3, r16
	ldd	r16, Z+D_ClusterH+0
	std	Y+fcb_cluster+2, r16
attachcmd010:
	ldd	r16, Z+D_Cluster+1	; Copy lower 16-bit of clusternumber
	std	Y+fcb_cluster+1, r16
	ldd	r16, Z+D_Cluster+0
	std	Y+fcb_cluster+0, r16
	ldi	r16, low(pbuffer)
	std	Y+fcb_address+0, r16
	ldi	r16, high(pbuffer)
	std	Y+fcb_address+1, r16
	
	call	BuildFragList
	brcc	attachcmd020
	call	print
	.db	"not enough memory to hold fragment list!", CR, LF, 0, 0

	ldd	r24, Y+fcb_filename+0
	ldd	r25, Y+fcb_filename+1
	sbiw	r25:r24, 0
	breq	attachcmd015
	call	free
attachcmd015:
	movw	r25:r24, yh:yl
	call	free

	ldi	yl, low(pdircluster)
	ldi	yh, high(pdircluster)
	call	startclusterrest
	clc
	rjmp	attachcmdexit
;
;	Y has a valid file descriptor block 
;
attachcmd020:
	ldd	xl, Y+fcb_filename+0	; Print full path name
	ldd	xh, Y+fcb_filename+1
	cp	xl, zero
	cpc	xh, zero
	breq	attachcmd220
	ldi	r24, DELIM
	call	serout
attachcmd200:
	ld	r24, X+
	tst	r24
	breq	attachcmd210
	call	serout
	rjmp	attachcmd200
attachcmd210:
	call	seroutcrlf
attachcmd220:
	rcall	printfraglist		; print fragments info
	ldd	r16, Y+fcb_flag
	sbrs	r16, F_Image		; check if it was a valid image
	rjmp	detachunitfile		; no, so we need to deallocate everything

	ldd	zl, Y+fcb_drvtab+0	; get drive table entry
	ldd	zh, Y+fcb_drvtab+1
	adiw	zh:zl, drv_typ		; 
	lpm	r16, Z			; Get drive type
	lds	zl, attunit		; get unit and convert to
	swap	zl
	clr	zh
	subi	zl, low(-unittable)
	sbci	zh, high(-unittable)	; unit control block address
;
;
;
	std	Z+ucb_type, r16	; Set drive type

	ldi	r16, (1<<ucb__rdy) | (1<<ucb__file)
	std	Z+ucb_status, r16	; Set status

	std	Z+ucb_diskaddr+0, zero	; Set current disk address
	std	Z+ucb_diskaddr+1, zero
	
	std	Z+ucb_imgptr+0, yl	; Link file control block
	std	Z+ucb_imgptr+1, yh
	clc
attachcmdexit:
	pop	yh
	pop	yl
	pop	xh
	pop	xl
	ret
;--------------------------------------------------------------------------
;
;	New "type <filename>" command that makes use of the new file IO
;	primitives.
;
cmdtype:
	ldi	yl, low(pdircluster)
	ldi	yh, high(pdircluster)
	rcall	startclustersave
	lds	xl, cdstring+2
	lds	xh, cdstring+3
	st	X, zero			; Zero Terminate the string
	lds	xl, cdstring+0
	lds	xh, cdstring+1
	rcall	chkrootdir		; Check for absolute path
	brne	cmdtype010		; 
	call	print			; Just a / is not a file
	.db	"Type - Not a file!", CR, LF, 0, 0
	rjmp	cmdtype100
cmdtype010:
	call	Name2DirEntry		; Check if file exists
	brcc	cmdtype020
	call	print
	.db	"Type File not found!", CR, LF, 0, 0
	rjmp	cmdtype100
cmdtype020:
	ldd	zl, Y+P_DirPointer+0
	ldd	zh, Y+P_DirPointer+1
	ldd	r16, Z+D_Attr
	sbrs	r16, A_Directory	; Check if file is not a directory
	rjmp	cmdtype030
	call	print
	.db	"Type - Not a file!", CR, LF, 0, 0
	rjmp	cmdtype100
cmdtype030:
	call	ReadFileOpen		; Open the file
	brcc	cmdtype050
	sts	pprint+0, r24
	call	print
	.db	"Type - open error 0x:", 0x80, CR, LF, 0, 0
	rjmp	cmdtype100
cmdtype050:
	call	ReadFileByte		; Get a byte
	brcs	cmdtype090		; Assume end of file
	cpi	r24, LF
	breq	cmdtype070
	cpi	r24, CR
	breq	cmdtype080
cmdtype060:
	sbrc	r24, 7
	ldi	r24, '.'
	call	serout
	rjmp	cmdtype050
cmdtype070:
	call	seroutcrlf
	call	ReadFileByte
	brcs	cmdtype090
	cpi	r24, CR
	breq	cmdtype050
	rjmp	cmdtype060
cmdtype080:
	call	seroutcrlf
	call	ReadFileByte
	brcs	cmdtype090
	cpi	r24, LF
	breq	cmdtype050
	rjmp	cmdtype060
cmdtype090:
	call	ReadFileClose		; Close file
cmdtype100:
	rcall	startclusterrest	; type never changes working directory
	clc
	ret
;--------------------------------------------------------------------------
;
;	Load a BootROM image from a file, it will read the first 512 bytes
;	of the file or less if the file has less than 512 bytes. It assumes
;	just a binary blob, no header and no checks are performed.
;
cmdromload:
	ldi	yl, low(pdircluster)
	ldi	yh, high(pdircluster)
	
	.if	0==1
	lds	xl, cdstring+0
	lds	xh, cdstring+1
	sts	pprint+0, xl
	sts	pprint+1, xh
	ld	r16, X
	sts	pprint+4, r16
	lds	xl, cdstring+2
	lds	xh, cdstring+3
	sts	pprint+2, xl
	sts	pprint+3, xh
	ld	r16, X
	sts	pprint+5, r16
	call	print
	.db	"Filename begins with 0x", 0x84, CR, LF
	.db	"Filename ends with ..0x", 0x85, CR, LF
	.db	"String starts at ....0x", 0x81, 0x80, CR, LF, SPACE
	.db	"String ends at ......0x", 0x83, 0x82, CR, LF, 0
	.endif

	lds	xl, cdstring+2
	lds	xh, cdstring+3
	st	X, zero			; Zero Terminate the string
	lds	xl, cdstring+0
	lds	xh, cdstring+1
	rcall	startclustersave
	rcall	chkrootdir
	brne	cmdromload010
	call	print
	.db	"ROM Load - Not a file!", CR, LF, 0, 0
	rjmp	cmdromload100	

cmdromload010:
	call	Name2DirEntry
	brcc	cmdromload020
	call	print
	.db	"ROM Load -File not found!", CR, LF, 0
	rjmp	cmdromload100	

cmdromload020:
	ldd	zl, Y+P_DirPointer+0
	ldd	zh, Y+P_DirPointer+1
	ldd	r16, Z+D_Attr
	sbrs	r16, A_Directory
	rjmp	cmdromload030
	call	print
	.db	"ROM Load - Not a file!", CR, LF, 0, 0
	rjmp	cmdromload100	

cmdromload030:
	call	ReadFileOpen
	brcc	cmdromload040
	sts	pprint+0, r24
	call	print
	.db	"ROM Load - open error 0x:", 0x80, CR, LF, 0, 0
	rjmp	cmdromload100	

cmdromload040:
	ldi	zl, low(softrombuffer)
	ldi	zh, high(softrombuffer)
	ldi	xl, low(softromsize)
	ldi	xh, high(softromsize)
cmdromload080:
	call	ReadFileByte
	brcs	cmdromload090
	st	Z+, r24
	sbiw	xh:xl, 1
	brne	cmdromload080

cmdromload090:
	call	ReadFileClose
cmdromload100:
	rcall	startclusterrest
	clc
	ret	
;--------------------------------------------------------------------------
;
;	pwd	- print working directory
;
pwdcmd:
	push	yl
	push	yh
	rcall	checkvolume
	brcc	pwdcmd005
	rcall	novolume
	rjmp	pwdcmdexit
pwdcmd005:
	ldi	yl, low(Path)
	ldi	yh, high(Path)
	call	print
;	.db	"C:"			; Only when using a Windows file delimiter
	.db	DELIM, 0
pwdcmd010:
	ld	r24, Y+
	tst	r24
	breq	pwdcmd020
pwdcmd015:
	call	serout
	rjmp	pwdcmd010
pwdcmd020:
	call	seroutcrlf
pwdcmdexit:
	clc
	pop	yh
	pop	yl
	ret

;--------------------------------------------------------------------------
;
;	activate <partition>
;
;	Change the partition type from MS-DOS FAT-12 to Linux so it can 
;	be attached
;

activpar092:
	lds	r16, attpart
	ori	r16, '0'
	sts	pprint+0, r16
	call	print
	.db	"Partition ", 0x90, " is not idle", CR, LF, 0
	clc
	rjmp	activparexit

;activpar091:
;	lds	r16, attpart
;	ori	r16, '0'
;	sts	pprint+0, r16
;	call	print
;	.db	"Partition ", 0x90, " is attached", CR, LF, 0
;	clc
;	rjmp	activparexit

activpar090:
	lds	r16, attpart
	ori	r16, '0'
	sts	pprint+0, r16
	call	print
	.db	"Partition ", 0x90, " not found", CR, LF, 0
	clc
	rjmp	activparexit

activpar:
	push	yl
	push	yh
	rcall	findpart
	brcs	activpar090
	ldd	r16, Y+pcb_status
	sbrs	r16, pcb__fat12
	rjmp	activpar092
	
	movw	Z, Y
	ldi	yl, low(pcluster)
	ldi	yh, high(pcluster)
	ldi	r16, low(pbuffer)
	std	Y+P_Address+0, r16
	ldi	r16, high(pbuffer)
	std	Y+P_Address+1, r16
	
	ldd	r16, Z+pcb_psector+0
	std	Y+P_Sector+0, r16	
	ldd	r16, Z+pcb_psector+1
	std	Y+P_Sector+1, r16	
	ldd	r16, Z+pcb_psector+2
	std	Y+P_Sector+2, r16	
	ldd	r16, Z+pcb_psector+3
	std	Y+P_Sector+3, r16	
	call	SD_CARD_READ
	brcc	activpar010

	call	print
	.db	"Error reading partition master sector", CR, LF, 0
	clc
	rjmp	activparexit
activpar010:	
	lds	r16, pbuffer+510
	cpi	r16, 0x55
	brne	activpar093
	lds	r16, pbuffer+511
	cpi	r16, 0xAA
	breq	activpar020

activpar093:
	call	print
	.db	"Invalid partition master sector", CR, LF, 0
	clc
	rjmp	activparexit

activpar020:
	ldd	xl, Z+pcb_poff
	ldi	xh, 0x01
	subi	xl, low(-pbuffer-M_PartType)
	sbci	xh, high(-pbuffer-M_PartType)
	ld	r16, X
	cpi	r16, 0x01
	breq	activpar030
	call	print
	.db	"Partition is not FAT-12", CR, LF, 0
	clc
	rjmp	activparexit
activpar030:
	ldi	r16, 0x83
	st	X, r16
	call	SD_CARD_WRITE
	brcc	activpar040
	call	print
	.db	"Error writing partition master sector", CR, LF, 0
	clc
	rjmp	activparexit
activpar040:
	std	Z+pcb_status, zero
	clc
activparexit:
	pop	yh
	pop	yl
	ret
	
	
;--------------------------------------------------------------------------
;
;	initialise <partition>
;
;	The bad sector file is written on the last track on the last surface
;	of a cartridge. For a description see
;	http://bitsavers.org/pdf/dec/disc/rl01_rl02/EK-RL012-UG-005_Sep81.tif.pdf
;
;	The first half of the track has factory written bad sector info and
;	the second half has field written bad sector info.
;
;	The information of each inforomation block is duplicated 5 times. Each block
;	occupies 1024bytes, which is 2 SD-Card blocks or 4 RL01/02 sectors.
;
;	Unused bad sector entries consists of all ones.
;
;	+-------------------------------------------------------------+
;	| 5 most significant octal digits of cartridge serial number  |
;	+-------------------------------------------------------------+
;	| 5 least significant octal digits of cartridge serial number |
;	+-------------------------------------------------------------+
;	| zeroes                                                      |
;	+-------------------------------------------------------------+
;	| zeroes                                                      |
;	+-------------------------------------------------------------+
;	| 1st bad sector entry (cylinder)                             |
;	+-------------------------------------------------------------+
;	| 1st bad sector entry (head, sector)                         |
;	+-------------------------------------------------------------+
;	...
;	+-------------------------------------------------------------+
;	| 125th bad sector entry (cylinder)                           |
;	+-------------------------------------------------------------+
;	| 125th bad sector entry (head, sector)                       |
;	+-------------------------------------------------------------+
;	| all ones                                                    |
;	+-------------------------------------------------------------+
;	| all ones                                                    |
;	+-------------------------------------------------------------+
;	...
;	+-------------------------------------------------------------+
;	| all ones                                                    |
;	+-------------------------------------------------------------+
;	| all ones                                                    |
;	+-------------------------------------------------------------+
;
initpar090:
	lds	r16, attpart
	ori	r16, '0'
	sts	pprint+0, r16
	call	print
	.db	"Partition ", 0x90, " not found", CR, LF, 0
	clc
	ret

initpar:
	rcall	findpart
	brcs	initpar090
	ldd	r16, Y+pcb_status
	sbrc	r16, pcb__att
	rjmp	initpar091		; Must not be attached
	sbrc	r16, pcb__fat12
	rjmp	initpar092		; Must have a valid partition type

;
;	Get Drive Type
;
	ldd	zl, Y+pcb_drvtab+0	; Get pointer to drive table
	ldd	zh, Y+pcb_drvtab+1
	subi	zl, low(-drv_siz)
	sbci	zh, high(-drv_siz)
	lpm	xl, Z+
	lpm	xh, Z+			; Get lower 16 bit of drive size
	subi	xl, low(20)
	sbci	xh, high(20)		; Last track is equivalent to 20 sectors

	movw	Z, Y			; Save partition control block pointer
	ldi	yl, low(pcluster)	; Prepare IO control block
	ldi	yh, high(pcluster)

	ldi	r16, low(pbuffer)
	std	Y+P_Address+0, r16
	ldi	r16, high(pbuffer)
	std	Y+P_Address+1, r16

	ldd	r16, Z+pcb_start+0	; Copy partition start sector
	add	r16, xl
	std	Y+P_Sector+0, r16	
	ldd	r16, Z+pcb_start+1
	adc	r16, xh
	std	Y+P_Sector+1, r16	
	ldd	r16, Z+pcb_start+2
	adc	r16, zero
	std	Y+P_Sector+2, r16	
	ldd	r16, Z+pcb_start+3
	adc	r16, zero
	std	Y+P_Sector+3, r16	


	ldi	r16, 0xff
	clr	r18
	ldd	Xl, Y+P_Address+0
	ldd	xh, Y+P_Address+1
	
initpar010:				; Initialize the block buffer with all ones
	st	X+, r16
	st	X+, r16
	dec	r18
	brne	initpar010

	ldi	r18, 10		; Repeat 10 times

	ldd	r16, Y+P_Sector+0	; Get sector for output messages
	sts	pprint+0, r16
	ldd	r16, Y+P_Sector+1
	sts	pprint+1, r16
	ldd	r16, Y+P_Sector+2
	sts	pprint+2, r16
	ldd	r16, Y+P_Sector+3
	sts	pprint+3, r16		

initpar020:
	rcall	initparbsfa		; Part A : Serial Number
	call	SD_CARD_WRITE
	call	print
	.db	"Init Par: Write A Sector 0x", 0x83, 0x82, 0x81, 0x80, CR, LF, 0
	rcall	initparinc

	rcall	initparbsfb		; Part B : All Ones
	call	SD_CARD_WRITE
	call	print
	.db	"Init Par: Write B Sector 0x", 0x83, 0x82, 0x81, 0x80, CR, LF, 0
	rcall	initparinc
	

	dec	r18
	brne	initpar020
	clc
	ret	

initpar091:
	lds	r16, attpart
	ori	r16, '0'
	sts	pprint+0, r16
	call	print
	.db	"Partition ", 0x90, " is attached", CR, LF, 0
	clc
	ret

initpar092:
	lds	r16, attpart
	ori	r16, '0'
	sts	pprint+0, r16
	call	print
	.db	"Partition ", 0x90, " is idle", CR, LF, 0
	clc
	ret
;
;	Write bad sector file section A  inlcuding hex encoded version and issue date
;	as the serial number as hex digits VVYYMMDD
;
initparbsfa:
	ldi	r16, 0x23		; VV	Version 2.3	
	sts	pbuffer+0, r16
	ldi	r16, 0x19		; YY	Year 19 (for 2019)
	sts	pbuffer+1, r16
	ldi	r16, 0x07		; MM	Month 07
	sts	pbuffer+2, r16
	ldi	r16, 0x31		; DD	Day 31
	sts	pbuffer+3, r16
	sts	pbuffer+4, zero
	sts	pbuffer+5, zero
	sts	pbuffer+6, zero
	sts	pbuffer+7, zero
	ret
;
;	Write bad sector file section B (all ones)
;	
initparbsfb:
	ldi	r16, 0xff
	sts	pbuffer+0, r16
	sts	pbuffer+1, r16 
	sts	pbuffer+2, r16
	sts	pbuffer+3, r16
	sts	pbuffer+4, r16
	sts	pbuffer+5, r16
	sts	pbuffer+6, r16
	sts	pbuffer+7, r16
	ret
;
;	Increment Sector
;
initparinc:
	ldd	r16, Y+P_Sector+0
;	add	r16, one
	subi	r16, byte1(-1)
	sts	pprint+0, r16
	std	Y+P_Sector+0, r16
	ldd	r16, Y+P_Sector+1
;	adc	r16, zero
	sbci	r16, byte2(-1)
	sts	pprint+1, r16
	std	Y+P_Sector+1, r16
	ldd	r16, Y+P_Sector+2
;	adc	r16, zero
	sbci	r16, byte3(-1)
	sts	pprint+2, r16
	std	Y+P_Sector+2, r16
	ldd	r16, Y+P_Sector+3
;	adc	r16, zero
	sbci	r16, byte4(-1)
	sts	pprint+3, r16
	std	Y+P_Sector+3, r16
	ret
;--------------------------------------------------------------------------
;
;	attach <unit> <partition>
;
attachpar:
	push	yl
	push	yh
	rcall	findpart
	brcs	attachpar090
	ldd	r16, Y+pcb_status
	sbrc	r16, pcb__att
	rjmp	attachpar091
	sbrc	r16, pcb__fat12
	rjmp	attachpar092
	sbr	r16, (1<<pcb__att)
	std	Y+pcb_status, r16

	ldd	zl, Y+pcb_drvtab+0
	ldd	zh, Y+pcb_drvtab+1
	adiw	zh:zl, drv_typ
	lpm	r16, Z			; Get drive type
	
	push	r16
	rcall	checkunit
	pop	r16
	brcs	attachpar030
	
	std	Z+ucb_type, r16	; Set drive type
	ldi	r16, (1<<ucb__rdy) | (1<<ucb__part)
	std	Z+ucb_status, r16	; Set status
	std	Z+ucb_diskaddr+0, zero	; Set current disk address
	std	Z+ucb_diskaddr+1, zero
	std	Z+ucb_imgptr+0, yl	; Link partition control block
	std	Z+ucb_imgptr+1, yh
attachpar030:
	clc
	rjmp	attachparexit

attachpar090:
	lds	r16, attpart
	ori	r16, '0'
	sts	pprint+0, r16
	call	print
	.db	"Partition ", 0x90, " not found", CR, LF, 0
	clc
	rjmp	attachparexit

attachpar091:
	lds	r16, attpart
	ori	r16, '0'
	sts	pprint+0, r16
	call	print
	.db	"Partition ", 0x90, " is already attached", CR, LF, 0
	clc
	rjmp	attachparexit

attachpar092:
	lds	r16, attpart
	ori	r16, '0'
	sts	pprint+0, r16
	call	print
	.db	"Partition ", 0x90, " is inactive", CR, LF, 0
	clc
attachparexit:
	pop	yh
	pop	yl
	ret

;--------------------------------------------------------------------------
;
;	detach <unit>
;
detachunit:
	push	yl
	push	yh
	lds	yl, attunit
	sts	pprint+0, yl
	cpi	yl, units
	brlo	detachunit010
	call	print
	.db	"invalid unit number", CR, LF, 0
	rjmp	detachunitexit
detachunit010:
	swap	yl
	clr	yh
	subi	yl, low(-unittable)
	sbci	yh, high(-unittable)
	ldd	r16, Y+ucb_status
	andi	r16, (1<<ucb__part) | (1<<ucb__file)
	brne	detachunit020
	lds	r16, pprint+0
	ori	r16, '0'
	sts	pprint+0, r16
	call	print
	.db	"unit ", 0x90, " is not attached", CR, LF, 0, 0
	rjmp	detachunitexit

detachunit020:
	std	Y+ucb_status, zero	; 
	ldd	zl, Y+ucb_imgptr+0
	ldd	zh, Y+ucb_imgptr+1
	sbrc	r16, ucb__file
	rjmp	detachunitfile
	ldd	r16, Z+pcb_status
	cbr	r16, (1<<pcb__att)
	std	Z+pcb_status, r16
	rjmp	detachunitexit
;--------------------------------------------------------------------------
;
;	Dispose allocated memory of a file control block
;
;	Y	pointer to unit control block
;	Z	pointer to file control block
;
detachunitfile:
	ldd	r24, Z+fcb_filename+0	; free filename buffer
	ldd	r25, Z+fcb_filename+1
	sbiw	r25:r24, 0
	breq	detachunit090
	call	free
detachunit090:
	movw	Y, Z
	adiw	Z, fcb_fraglist
	call	FreeList
	movw	r25:r24, yh:yl
	call	free
detachunitexit:
	pop	yh
	pop	yl
	clc
	ret

;--------------------------------------------------------------------------
;
;	Print information about all system
;
cmdshowvers:
	ldi	zl, low(2*hello)
	ldi	zh, high(2*hello)

cmdshowvers010:
	lpm	r24 ,Z+ 
	tst	r24
	breq	cmdshowvers020
	call	serout
	brne	cmdshowvers010

cmdshowvers020:
	call	print
	.db	"CPLD Interface is: ", '0'+rlv12/10, '0'+rlv12%10, CR, LF, 0
	clc
	ret

;--------------------------------------------------------------------------
;
;	Print information about all units
;
cmdshowunits:
	push	xl
 	push	xh
	push	yl
	push	yh
	push	zl
	push	zh

	clr	r18
	ldi	yl, low(unittable)
	ldi	yh, high(unittable)
;
;
;
cmdshowunit:
	sts	pprint+0, yl		; unit control block address
	sts	pprint+1, yh		;
	mov	r16, r18
	ori	r16, '0'
	sts	pprint+6, r16
	ldd	r16, Y+ucb_status
	sbrc	r16, ucb__part
	rjmp	cmdshowunitpart
	sbrc	r16, ucb__file
	rjmp	cmdshowunitfile
	call	print
	.db	"Unit ", 0x96, " (0x", 0x81, 0x80, ") is not attached", CR, LF, CR, LF, 0
cmdshowunitnext:
	adiw	yh:yl, unitsize
	inc	r18
	cpi	r18, units
	brlo	cmdshowunit
	pop	zh
	pop	zl
	pop	yh
	pop	yl
	pop	xh
	pop	xl
	clc
	ret

cmdshowunitpart:
	ldd	zl, Y+ucb_imgptr+0
	ldd	zh, Y+ucb_imgptr+1
	
	sts	pprint+2, zl		; partition control block address
	sts	pprint+3, zh
	
	ldd	xl, Z+pcb_drvtab+0
	ldd	xh, Z+pcb_drvtab+1

	sts	pprint+4, xl		; drive table entry address
	sts	pprint+5, xh

	ldd	r16, Y+ucb_status
	sts	pprint+7, r16
	
	ldd	r16, Z+pcb_id
	sts	pprint+8, r16

	ldd	r16, Z+pcb_start+0
	sts	pprint+9, r16
	ldd	r16, Z+pcb_start+1
	sts	pprint+10, r16
	ldd	r16, Z+pcb_start+2
	sts	pprint+11, r16
	ldd	r16, Z+pcb_start+3
	sts	pprint+12, r16
	call	print
	.db	"Unit ", 0x96, " (0x", 0x81, 0x80, ") is attached to partition ", 0x88, " (0x", 0x83, 0x82, ") starting at sector 0x", 0x8c, 0x8b, 0x8a, 0x89, CR, LF, 0
	movw	Z, X
	
	rcall	cmdshowdriveinfo
	rjmp	cmdshowunitnext
	
cmdshowunitfile:
	ldd	zl, Y+ucb_imgptr+0
	ldd	zh, Y+ucb_imgptr+1
	sts	pprint+2, zl		; partition control block address
	sts	pprint+3, zh
	call	print
	.db	"Unit ", 0x96, " (0x", 0x81, 0x80, ") is attached to file (0x", 0x83, 0x82, ") /", 0, 0
	ldd	xl, Z+fcb_filename+0
	ldd	xh, Z+fcb_filename+1
cmdshowunitfile010:
	ld	r24, X+
	tst	r24
	breq	cmdshowunitfile020
	call	serout
	rjmp	cmdshowunitfile010
cmdshowunitfile020:
	call	seroutcrlf
	push	yl
	push	yh
	movw	yh:yl, zh:zl
	rcall	printfraglist
	pop	yh
	pop	yl
	ldd	xl, Z+fcb_drvtab+0
	ldd	xh, Z+fcb_drvtab+1
	sts	pprint+4, xl		; drive table entry address
	sts	pprint+5, xh
	movw	zh:zl, xh:xl
	rcall	cmdshowdriveinfo
	rjmp	cmdshowunitnext
;--------------------------------------------------------------------------
;
;
;
cmdshowpart:
	push	xl
 	push	xh
	push	yl
	push	yh
	push	zl
	push	zh
	ldi	yl, low(pcbqueue)
	ldi	yh, high(pcbqueue)
cmdshowpart010:
	ldd	xl, Y+0
	ldd	xh, Y+1
	cp	xl, zero
	cpc	xh, zero
	brne	cmdshowpartnext
	pop	zh
	pop	zl
	pop	yh
	pop	yl
	pop	xh
	pop	xl
	clc
	ret
	
cmdshowpartnext:
	movw	Y, X
	ldd	r16, Y+0		; Next partition control block
	sts	pprint+0, r16
	ldd	r16, Y+1
	sts	pprint+1, r16
	ldd	r16, Y+pcb_status	; Flags
	sts	pprint+2, r16
	ldd	r16, Y+pcb_id		; Unit
	sts	pprint+3, r16
	ldd	r16, Y+pcb_start+0	; Start
	sts	pprint+4, r16
	ldd	r16, Y+pcb_start+1
	sts	pprint+5, r16
	ldd	r16, Y+pcb_start+2
	sts	pprint+6, r16
	ldd	r16, Y+pcb_start+3
	sts	pprint+7, r16
	sts	pprint+8, yl
	sts	pprint+9, yh

	ldd	r16, Y+pcb_psector+0
	sts	pprint+10, r16
	ldd	r16, Y+pcb_psector+1
	sts	pprint+11, r16
	ldd	r16, Y+pcb_psector+2
	sts	pprint+12, r16
	ldd	r16, Y+pcb_psector+3
	sts	pprint+13, r16


	call	print
	.db	"Partition ", 0x83, " (pcb:0x", 0x89, 0x88, ") starting at sector 0x"
	.db	0x87, 0x086, 0x85, 0x84
	.db	" MBR at 0x"
	.db	0x8d, 0x8c, 0x8b, 0x8a, 0, 0

	ldd	r16, Y+pcb_status
	sbrc	r16, pcb__fat12
	rjmp	cmdshowpart040
	sbrc	r16, pcb__fat
	rjmp	cmdshowfat
	sbrs	r16, pcb__att
	rjmp	cmdshowpart020
	call	print
	.db	" is attached", CR, LF, 0, 0
	rjmp	cmdshowpart030
cmdshowpart020:
	call	print
	.db	" is not attached", CR, LF, 0, 0
cmdshowpart030:
	ldd	zl, Y+pcb_drvtab+0
	ldd	zh, Y+pcb_drvtab+1
	rcall	cmdshowdriveinfo
	rjmp	cmdshowpart010

cmdshowpart040:
	sts	pprint+0, r16
	call	print
	.db	" is idle offset 0x01", 0x80, CR, LF, 0
	rjmp	cmdshowpart030

cmdshowfat:
	ldd	r16, Y+pcb_id
	sts	pprint+0, r16
	call	print
	.db	" is volume ", 0x90, ":", CR, LF, 0

	push	yl
	push	yh
	push	zl
	push	zh
	movw	Z, Y
	ldi	yl, low(pcluster)
	ldi	yh, high(pcluster)
	ldi	r16, low(pbuffer)
	std	Y+P_Address+0, r16
	ldi	r16, high(pbuffer)
	std	Y+P_Address+1, r16

	ldd	r16, Z+pcb_start+0
	std	Y+P_Sector+0, r16
	ldd	r16, Z+pcb_start+1
	std	Y+P_Sector+1, r16
	ldd	r16, Z+pcb_start+2
	std	Y+P_Sector+2, r16
	ldd	r16, Z+pcb_start+3
	std	Y+P_Sector+3, r16
	sbi	b_LED
	ldi	r17, led_time
	sts	led_oneshot, r17
	call	SD_CARD_READ
	brcs	cmdshowfat010
	
	call	print
	.db	TAB, "Label .................: ", '"', 0
	
	ldi	yl, low(pbuffer+V_FAT16Label)
	ldi	yh, high(pbuffer+V_FAT16Label)
	ldi	r18, 10
	lds	r24, VolStatus		;
	sbrs	r24, FAT32
	rjmp	cmdshowfat005
	ldi	yl, low(pbuffer+V_FAT32Label)
	ldi	yh, high(pbuffer+V_FAT32Label)
cmdshowfat005:
	ld	r24, Y+
	call	serout
	dec	r18
	brpl	cmdshowfat005
	call	print
	.db	'"', CR, LF, 0
	rcall	cmdshowfatsub
	lds	r24, VolStatus		;
	sbrc	r24, FAT32
	rcall	cmdshowfatsub32
cmdshowfat010:
	pop	zh
	pop	zl
	pop	yh
	pop	yl
	rjmp	cmdshowpart010
	
cmdshowfatsub:
	lds	yl, pbuffer+V_BytesPSect+0
	lds	yh, pbuffer+V_BytesPSect+1
	sts	pprint+0, yl
	sts	pprint+1, yh
	lds	yl, pbuffer+V_SecPClust
	sts	pprint+2, yl
	sts	pprint+3, zero
	lds	yl, pbuffer+V_NumFATs
	sts	pprint+4, yl
	sts	pprint+5, zero
	lds	yl, pbuffer+V_SecPFAT+0
	lds	yh, pbuffer+V_SecPFAT+1
	sts	pprint+6, yl
	sts	pprint+7, yh
	lds	yl, pbuffer+V_PartSize+0
	lds	yh, pbuffer+V_PartSize+1
	sts	pprint+8, yl
	sts	pprint+9, yh
	lds	yl, pbuffer+V_PartSize+2
	lds	yh, pbuffer+V_PartSize+3
	sts	pprint+10, yl
	sts	pprint+11, yh
	call	print
	.db	TAB, "Bytes per Sector ......:        ", 0xC0, CR, LF
	.db	TAB, "Sectors per Cluster ...:        ", 0xC2, CR, LF
	.db	TAB, "Number of FATs ........:        ", 0xC4, CR, LF
	.db	TAB, "Partition Size ........:", 0xD8, CR, LF, 0, 0
	ret
	
cmdshowfatsub32:
	lds	yl, pbuffer+V_SecPFAT32+0
	lds	yh, pbuffer+V_SecPFAT32+1
	sts	pprint+0, yl
	sts	pprint+1, yh
	lds	yl, pbuffer+V_SecPFAT32+2
	lds	yh, pbuffer+V_SecPFAT32+3
	sts	pprint+2, yl
	sts	pprint+3, yh
	lds	yl, pbuffer+V_FAT32RootClus+0
	lds	yh, pbuffer+V_FAT32RootClus+1
	sts	pprint+4, yl
	sts	pprint+5, yh
	lds	yl, pbuffer+V_FAT32RootClus+2
	lds	yh, pbuffer+V_FAT32RootClus+3
	sts	pprint+6, yl
	sts	pprint+7, yh
	call	print
	.db	TAB, "Sectors per FAT .......:", 0xD0, CR, LF
	.db	TAB, "Root Cluster ..........:", 0xD4, CR, LF
	ret
;--------------------------------------------------------------------------
;
;	show drive information
;
cmdshowdriveinfo:
	lpm	r16, Z+		; Size
	sts	pprint+0, r16
	lpm	r16, Z+
	sts	pprint+1, r16
	lpm	r16, Z+
	sts	pprint+2, r16
	lpm	r16, Z+
	sts	pprint+3, r16
	lpm	r16, Z+		; Geometry
	sts	pprint+4, r16
	lpm	r16, Z+
	sts	pprint+5, r16
	lpm	r16, Z+
	sts	pprint+6, r16
	lpm	r16, Z+
	sts	pprint+7, r16
	lpm	r16, Z+		; Type/Flags
	sts	pprint+8, r16
	lpm	r16, Z+
	sts	pprint+9, r16
	lpm	r16, Z+		; Name
	sts	pprint+10, r16
	lpm	r16, Z+
	sts	pprint+11, r16
	lpm	r16, Z+
	sts	pprint+12, r16
	lpm	r16, Z+
	sts	pprint+13, r16
	call	print
	.db	"  Drive has 0x", 0x83, 0x82, 0x81, 0x80, " blocks, 0x", 0x84, " sectors/track, 0x", 0x85, " tracks/cylinder and 0x", 0x87, 0x86, " cylinders  ", CR, LF
	.db	"  Drive type/flags and name 0x", 0x88, "/0x", 0x89, "  ", 0x9a, 0x9b, 0x9c, 0x9d, CR, LF, CR, LF, 0
	ret
	
;--------------------------------------------------------------------------
;
;	Print Port Status
;
cmdshowstatus:
	call	print
	lds	r16, log_pointer+0
	lds	r17, log_pointer+1
	sts	pprint+0, r16
	sts	pprint+1, r17
	.db	CR, LF, "Log_Ptr.:", 0x81, 0x80, 0x00
;

	ldi	r16, '0'
	sbic	b_CRDY
	ldi	r16, '1'
	sts	pprint+0, r16
	call	print
	.db	CR, LF, "CRDY....:", 0x90, 0x00, 0x00
;
	ldi	r16, '0'
	sbic	b_IRQST
	ldi	r16, '1'
	sts	pprint+0, r16
	call	print
	.db	CR, LF, "IRQST...:", 0x90, 0x00, 0x00
;
	ldi	r16, '0'
	sbic	i_INTQ
	ldi	r16, '1'
	sts	pprint+0, r16
	call	print
	.db	CR, LF, "INTQ....:", 0x90, 0x00, 0x00
;
	ldi	r16, '0'
	sbic	i_INTI
	ldi	r16, '1'
	sts	pprint+0, r16
	call	print
	.db	CR, LF, "INTI....:", 0x90, 0x00, 0x00
;
	lds	r16, INTQ_count
	sts	pprint, r16
	sts	INTQ_count, zero
	call	print
	.db	CR, LF, "IntQCnt.:", 0x80, 0x00, 0x00
;
	lds	r16, INTI_count
	sts	pprint, r16
	sts	INTI_count, zero
	call	print
	.db	CR, LF, "IntICnt.:", 0x80, 0x00, 0x00
;
	lds	r16, INIT_count
	sts	pprint, r16
	sts	INIT_count, zero
	call	print
	.db	CR, LF, "InitCnt.:", 0x80, 0x00, 0x00
;
	lds	r16, INTB_count
	sts	pprint, r16
	sts	INTB_count, zero
	call	print
	.db	CR, LF, "BusyCnt.:", 0x80, 0x00, 0x00
;
	ldi	r16, '0'
	sbic	b_IACK
	ldi	r16, '1'
	sts	pprint+0, r16
	call	print
	.db	CR, LF, "IACK....:", 0x90, 0x00, 0x00
;
	ldi	r16, '0'
	sbic	b_DMR
	ldi	r16, '1'
	sts	pprint+0, r16
	.db	CR, LF, "DMR.....:", 0x90, 0x00, 0x00
;
	ldi	r16, '0'
	sbic	i_DMG
	ldi	r16, '1'
	sts	pprint+0, r16
	call	print
	.db	CR, LF, "DMG.....:", 0x90, 0x00, 0x00
;
	ldi	r16, '0'
	sbic	b_ABORT
	ldi	r16, '1'
	sts	pprint+0, r16
	call	print
	.db	CR, LF, "ABORT...:", 0x90, 0x00, 0x00
;
	in	r16, GPIOR0
	sts	pprint, r16
	call	print
	.db	CR, LF, "GPIOR0..:", 0x80, 0x00, 0x00
;
	in	r16, SREG
	sts	pprint, r16	
	call	print
	.db	CR, LF, "SREG....:", 0x80, 0x00, 0x00
;

	lds	r16, CSRL
	lds	r17, CSRH
	sts	pprint+0, r16
	sts	pprint+1, r17
	call	print
	.db	CR, LF, "CSR.....:", 0xa0, 0x00, 0x00
	lds	r16, BARL
	lds	r17, BARH
	sts	pprint+0, r16
	sts	pprint+1, r17
	call	print
	.db	CR, LF, "BAR.....:", 0xa0, 0x00, 0x00
	lds	r16, DARL
	lds	r17, DARH
	sts	pprint+0, r16
	sts	pprint+1, r17
	call	print
	.db	CR, LF, "DAR.....:", 0xa0, 0x00, 0x00
	lds	r16, MPRL
	lds	r17, MPRH
	sts	pprint+0, r16
	sts	pprint+1, r17
	call	print
	.db	CR, LF, "MPR.....:", 0xa0, 0x00, 0x00
	lds	r16, BAEL
	lds	r17, BAEH
	sts	pprint+0, r16
	sts	pprint+1, r17
	call	print
	.db	CR, LF, "BAE.....:", 0xa0, 0x00, 0x00
	
	call	seroutcrlf
	clc
	ret
;--------------------------------------------------------------------------
;
;	ROM -	Typicall the PDP-11 expects a BootROM in the IO Page at
;		173000, or 17773000 in ODT. Especially the DJC11 can be
;		programmed with the power-up mode to start execution with
;		this address. The RLV12 Emulator can emulate a BootROM.
;		The behaviour can be set via sofftware. Note that the
;		emulation is very slow, i.e. execution of code in the Boot
;		ROM is limited to apporx 100'000 instructions per second, 
;		about ten times slower than execution of code from RAM.
;		This is intended for BootROMs, not for diagnostics ROM.
;
;	bootrom				; Enable ROM at 17773000
;	no bootrom			; Disable ROM at 17773000
;	bootrom load <filename>		; Load Romimage from file
;	bootrom rw			; Write enable ROM at 17773000
;	bootrom ro			; Write disable ROM at 17773000
;	bootrom reset			; Reset ROM at 17773000 with default image
;	show bootrom			; Show emulation status of ROM at 17773000
;
cmdrom:	
	lds	r16, tpflags
	sbrc	r16, tp__no
	rjmp	cmdromno

	cli
	cbi	b_RD
	ldi	r16, 0xff
	out	dataportdir, r16
	ldi	r16, 7
	out	dataportout, r16
	sbi	b_ALEW
	cbi	b_ALEW
	ldi	r16, 1
	out	dataportout, r16
	sts	romstatus, r16
	sbi	b_WR
	cbi	b_WR
	sei
	clc
	ret
cmdromno:
	cli
	cbi	b_RD
	ldi	r16, 0xff
	out	dataportdir, r16
	ldi	r16, 7
	out	dataportout, r16
	sbi	b_ALEW
	cbi	b_ALEW
	out	dataportout, zero
	sts	romstatus, zero
	sbi	b_WR
	cbi	b_WR
	sei
	clc
	ret
	
cmdshowrom:
	call	print
	.db	"Boot ROM is", 0
	lds	r16, romstatus
	tst	r16
	breq	cmdshowromdis
	call	print
	.db	" enabled and ", 0
	sbrs	r16, 1
	rjmp	cmdshowromrw
	call	print
	.db	"read-only.", CR, LF, 0, 0
	clc
	ret
cmdshowromrw:
	call	print
	.db	"read-write.", CR, LF, 0
	clc
	ret
cmdshowromdis:
	call	print
	.db	" disabled. ", CR, LF, 0
	clc
	ret

cmdromro:
	lds	r16, romstatus
	sbr	r16, (1<<1)
	sts	romstatus, r16
	clc
	ret

cmdromrw:
	lds	r16, romstatus
	cbr	r16, (1<<1)
	sts	romstatus, r16
	clc
	ret
	
cmdromreset:
	call	print
	.db	"Resetting Boot ROM to built in ROM.", CR, LF, 0
	push	xh
	push	xl
	ldi	zl, low(2*rom173000)
	ldi	zh, high(2*rom173000)
	ldi	yl, low(softrombuffer)
	ldi	yh, high(softrombuffer)
	ldi	xl, low(softromsize)
	ldi	xh, high(softromsize)
cmdromreset010:
	lpm	r16, Z+
	st	Y+, r16
	sbiw	xh:xl, 1
	brne	cmdromreset010
	pop	xl
	pop	xh
	clc
	ret

;--------------------------------------------------------------------------
;
;	Command routines 
;
cmdcdroot:
	push	yl
	push	yh
	ldi	yl, low(pdircluster)
	ldi	yh, high(pdircluster)
	std	Y+P_StartClust+0, zero
	std	Y+P_StartClust+1, zero
	std	Y+P_StartClust+2, zero
	std	Y+P_StartClust+3, zero
	sts	Path, zero
	pop	yh
	pop	yl
	clc
	ret
;
;	Print Number
;
prtnbr:
	lds	r16, nbr+0
	sts	pprint+0, r16
	lds	r16, nbr+1
	sts	pprint+1, r16
	lds	r16, nbr+2
	sts	pprint+2, r16
	lds	r16, nbr+3
	sts	pprint+3, r16

	call	print
	.db	"Number is:", 0xd0, "., 0", 0xb0, ", 0x", 0x83, 0x82, 0x81, 0x80
	.db	CR, LF, 0, 0
	clc
	ret

dmatest:
;
;	dmatest <address> <pattern>
;
;	nbr	DMA start address
;	pattern	DMA pattern
;
	push	r16
	push	r17
	push	r18
	push	r19
	push	r20
	push	xl
	push	xh
	push	yl
	push	yh
	push	zl
	push	zh
	
	lds	r16, nbr+0
	lds	r17, nbr+1
	lds	r18, nbr+2
	lds	r19, nbr+3
	sts	pprint+0, r16
	sts	pprint+1, r17
	sts	pprint+2, r18
	sts	pprint+3, r19

	andi	r16, 0xFE		; DMA Write
	andi	r18, 0x3F		; Mask excess bits
	
	dmaaddr	r16, r17, r18

	ldi	xl, low(0x1000)
	ldi	xh, high(0x1000)

	lds	r18, pattern+0
	lds	r19, pattern+1
	sts	pprint+0, r18
	sts	pprint+1, r19
	
	clr	r20			; Test always a block of 4kbyte
	clr	r16
	clr	r17

dmatestloop1:
	rcall	dmatestwrite
	rcall	dmatestwrite
	rcall	dmatestwrite
	rcall	dmatestwrite
	rcall	dmatestwrite
	rcall	dmatestwrite
	rcall	dmatestwrite
	rcall	dmatestwrite
	dec	r20
	brne	dmatestloop1
;
;
;
	ldi	r16, 32
	sts	dmalimit, r16		; only 32 messages

	lds	r16, nbr+0
	lds	r17, nbr+1
	lds	r18, nbr+2
	lds	r19, nbr+3

	ori	r16, 0x01		; DMA Read
	andi	r18, 0x3F		; Mask excess bits
	
	dmaaddr	r16, r17, r18

	ldi	xl, low(0x1000)
	ldi	xh, high(0x1000)

	clr	r20			; Test always a block of 4kbyte

dmatestloop2:
	rcall	dmatestread
	rcall	dmatestread
	rcall	dmatestread
	rcall	dmatestread
	rcall	dmatestread
	rcall	dmatestread
	rcall	dmatestread
	rcall	dmatestread
	dec	r20
	brne	dmatestloop2

	pop	zh
	pop	zl
	pop	yh
	pop	yl
	pop	xh
	pop	xl
	pop	r20
	pop	r19
	pop	r18
	pop	r17
	pop	r16
	clc
	ret

dmatestwrite:
	st	X+, r16			; Keep value written in buffer
	st	X+, r17
	dmawrt	r16, r17		; Write value via DMA to host memory
	brcc	dmatestwrite005
	rcall	dmatesttmo
dmatestwrite005:
	add	r16, r18		; Calculate next value
	adc	r17, r19
	ret

dmatestread:
	dmaread	r16, r17		; Read value via DMA from host memory
	brcc	dmatestread005
	rcall	dmatesttmo
dmatestread005:
	ld	r18, X+			; Get Value from buffer
	ld	r19, X+
	cp	r16, r18		; Compare
	cpc	r17, r19
	breq	dmatestread010		; ok
	sts	pprint+8, r18		; Save both values in print output values
	sts	pprint+9, r19
	sts	pprint+10, r16
	sts	pprint+11, r17
	lds	r16, dmalimit		; see how many messages we already created
	tst	r16			; 
	breq	dmatestread010		; limit reached
	dec	r16			; decrement remaining messages to send
	sts	dmalimit, r16
	call	print			; write message
	.db	"DMA Test Expected 0x", 0x89, 0x88, ", but we got 0x", 0x8b, 0x8a, CR, LF, 0
dmatestread010:
	ret	
	
dmatesttmo:
	lds	r16, dmalimit
	tst	r16
	breq	dmatesttmo010
	dec	r16
	sts	dmalimit, r16

	lds	r16, nbr+0
	add	r16, xl
	sts	pprint+8, r16

	mov	r16, xh
	andi	r16, 0x0F
	lds	r17, nbr+1
	adc	r16, r17
	sts	pprint+9, r16
	lds	r16, nbr+2
	adc	r16, zero
	sts	pprint+10, r16
	call	print
	.db	"DMA Test Timeout at ", 0xb8, CR, LF, 0
dmatesttmo010:
	ret
;
;
;
cmddmaaddr:
	lds	r16, nbr+0
	andi	r16, 0xFE
	sts	dmapdp11+0, r16

	lds	r16, nbr+1
	sts	dmapdp11+1, r16

	lds	r16, nbr+2
	andi	r16, 0x3F
	sts	dmapdp11+2, r16
	clc
	ret
	
cmddmaread:
	lds	r16, dmapdp11+0
	lds	r17, dmapdp11+1
	lds	r18, dmapdp11+2
	ori	r16, 0x01
	sts	pprint+6, r18
	sts	pprint+4, r16
	sts	pprint+5, r17
	dmaaddr	r16, r17, r18
	dmaread	r16, r17
	sts	pprint+0, r16
	sts	pprint+1, r17	
	call	print
	.db	"Read DMA from 0x", 0x86, 0x85, 0x84, " returns 0x", 0x81, 0x80, CR, LF, 0, 0
	clc
	ret
	
cmddmawrite:
	lds	r16, dmapdp11+0
	lds	r17, dmapdp11+1
	lds	r18, dmapdp11+2
	andi	r16, 0xFE
	dmaaddr	r16, r17, r18
	lds	r16, nbr+0
	lds	r17, nbr+1
	sts	pprint+0, r16
	sts	pprint+1, r17
	dmawrt	r16, r17
	call	print
	.db	"Write DMA to 0x", 0x86, 0x85, 0x84, " value 0x", 0x81, 0x80, CR, LF, 0
	clc
	ret
;--------------------------------------------------------------------------
;
;	dump block from unit
;
cmddumpbl:
	lds	zl, dumpunit
	andi	zl, 0x03
	swap	zl
	clr	zh
	subi	zl, low(-unittable)
	sbci	zh, high(-unittable)	
	ldd	yl, Z+ucb_imgptr+0	; Get pointer to disk image control block
	ldd	yh, Z+ucb_imgptr+1
	ldd	r16, Z+ucb_status	; Get the status
	sbrs	r16, ucb__file		; Is unit attached to a file?
	rjmp	cmddumppart		; no its a partition
;
;	A file is attached, Y points to the fcb. We put the LBN to the P_Cluster
;	offset of the fcb (file control block) which is then translated to a physical
;	block number by using the fragment list attached to the file control block
;
	lds	r16, dumpblock+0
	std	Y+P_Cluster+0, r16	; Set start LBN =0 for read or write
	lds	r16, dumpblock+1
	std	Y+P_Cluster+1, r16
	lds	r16, dumpblock+2
	std	Y+P_Cluster+2, r16
	lds	r16, dumpblock+3
	std	Y+P_Cluster+3, r16
	call	Logical2Physical	; Convert to PBN (pyhsical block number)
	rjmp	cmddumpblock
	
cmddumppart:
	ldi	zl, low(pcluster)	; Setup parameter block for general IO
	ldi	zh, high(pcluster)	; 

	ldd	r16, Y+pcb_start+0	; Get start of partition
	lds	r17, dumpblock+0
	add	r16, r17
	std	Z+P_Sector+0, r16	; Set start sector for read or write
	ldd	r16, Y+pcb_start+1
	lds	r17, dumpblock+1
	adc	r16, r17
	std	Z+P_Sector+1, r16
	ldd	r16, Y+pcb_start+2
	lds	r17, dumpblock+2
	adc	r16, r17
	std	Z+P_Sector+2, r16
	ldd	r16, Y+pcb_start+3
	lds	r17, dumpblock+3
	adc	r16, r17
	std	Z+P_Sector+3, r16
	movw	Y, Z
;	
;
;	Set DMA Start Address into CPLD registers 4,5 and 7
;
cmddumpblock:
	ldi	xl, low(pbuffer)	; 
	ldi	xh, high(pbuffer)	; 
	std	Y+P_Address+0, xl	; Set buffer address for SD-Card block
	std	Y+P_Address+1, xh	; 
	ldi	r16, led_time
	sts	led_oneshot, r16
	sbi	b_LED
	call	SD_CARD_READ		; 

	ldi	r18, 32		; 32 x 16 bytes = 1 Block
	clr	zl
	clr	zh
	ldd	xl, Y+P_Address+0
	ldd	xh, Y+P_Address+1
cmddumpline:
	sts	pprint+0, zl
	sts	pprint+1, zh
	adiw	zh:zl, 16

	lds	r16, dumpswitch
	sbrs	r16, dumpswitch_h
	rjmp	cmddumplineo010
	call	print
	.db	"0x", 0x81, 0x80, ":", 0
	rcall	cmddumpcopyline	
 	call	print
	.db	" 0x", 0x81, 0x80, " 0x", 0x83, 0x82
	.db	" 0x", 0x85, 0x84, " 0x", 0x87, 0x86
	.db	" 0x", 0x89, 0x88, " 0x", 0x8b, 0x8a
	.db	" 0x", 0x8d, 0x8c, " 0x", 0x8f, 0x8e, 0, 0
	rjmp	cmddumplineo020

cmddumplineo010:
	call	print
	.db	0xA0, ": ", 0
	rcall	cmddumpcopyline	
 	call	print
 	.db	0xA0, " ", 0xA2, " ",0xA4, " ",0xA6, " " 
 	.db	0xA8, " ", 0xAA, " ",0xAC, " ",0xAE , 0

cmddumplineo020:
	lds	r16, dumpswitch
	sbrs	r16, dumpswitch_r
	brne	cmddumpline010
	call	print
	.db	" '", 0xE0, 0xE2, 0xE4, 0xE6, 0xE8, 0xEA, 0xEC, 0xEE, "'", 0
	
cmddumpline010:
	lds	r16, dumpswitch
	sbrs	r16, dumpswitch_c
	brne	cmddumpline020
	call	print
	.db	" '", 0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97
	.db	0x98, 0x99, 0x9A, 0x9B, 0x9C, 0x9D, 0x9E, 0x9F, "'", 0

cmddumpline020:

	call	seroutcrlf
	dec	r18
	breq	cmddumpline030
	rjmp	cmddumpline
cmddumpline030:
	clc
	ret

cmddumpcopyline:
	ld	r16, X+
 	sts	pprint+0, r16
	ld	r16, X+
 	sts	pprint+1, r16
	ld	r16, X+
 	sts	pprint+2, r16
	ld	r16, X+
 	sts	pprint+3, r16
	ld	r16, X+
 	sts	pprint+4, r16
	ld	r16, X+
 	sts	pprint+5, r16
	ld	r16, X+
 	sts	pprint+6, r16
	ld	r16, X+
 	sts	pprint+7, r16
	ld	r16, X+
 	sts	pprint+8, r16
	ld	r16, X+
 	sts	pprint+9, r16
	ld	r16, X+
 	sts	pprint+10, r16
	ld	r16, X+
 	sts	pprint+11, r16
	ld	r16, X+
 	sts	pprint+12, r16
	ld	r16, X+
 	sts	pprint+13, r16
	ld	r16, X+
 	sts	pprint+14, r16
	ld	r16, X+
 	sts	pprint+15, r16
	ret
;--------------------------------------------------------------------------
;
;	Make show free callable without changing registers to debug
;	MountVolume
;
showfree:
	push	r24
	push	r25
	push	xl
	push	xh
	push	yl
	push	yh
	push	zl
	push	zh
	call	print
	.db	CR, LF
	.db	"List of free memory blocks:", CR, LF, 0
	ldi	yl, low(heap)
	ldi	yh, high(heap)
showfree010:
	movw	Z, Y
	ldd	yl, Z+2
	ldd	yh, Z+3			; Address of next
	sbiw	yh:yl, 0
	breq	showfree090
	ldd	r24, Y+0
	ldd	r25, Y+1		; Get Size
	movw	xh:xl, yh:yl
	sbiw	r25:r24, 2		; Adjust to "user"
	adiw	xh:xl, 2
	sts	pprint+0, xh
	sts	pprint+1, xl
	sts	pprint+2, r25
	sts	pprint+3, r24
	call	print
	.db	TAB, "Start 0x", 0x80, 0x81, " Size 0x", 0x82, 0x83, CR, LF, 0
	rjmp	showfree010
showfree090:
	clc
	pop	zh
	pop	zl
	pop	yh
	pop	yl
	pop	xh
	pop	xl
	pop	r25
	pop	r24
	ret
	
;--------------------------------------------------------------------------
;
;	READcheck <block> <size> <addr>
;
;
readchk:
	lds	r16, rdchkblock+0
	sts	pprint+0, r16
	lds	r16, rdchkblock+1
	sts	pprint+1, r16

	lds	r16, rdchksize+0
	sts	pprint+2, r16
	lds	r16, rdchksize+1
	sts	pprint+3, r16

	lds	r16, rdchkaddr+0
	sts	pprint+4, r16
	lds	r16, rdchkaddr+1
	sts	pprint+5, r16
	lds	r16, rdchkaddr+2
	sts	pprint+6, r16
	call	print
	.db	"Read ", 0xa2, " blocks from LBN ", 0xa0, " to address ", 0xb4, CR, LF, 0
;	clc
;	ret


	ldi	yl, low(unittable)	; 
	ldi	yh, high(unittable)	; 

	lds	r16, rdchkaddr+0
	lds	r17, rdchkaddr+1
	lds	r18, rdchkaddr+2
	andi	r16, 0xFE		; DMA Write
	andi	r18, 0x3F
	dmaaddr	r16, r17, r18

	lds	r24, rdchkblock+0
	lds	r25, rdchkblock+1
;?	call	rvl12_dar2lbn		; In case we want DAR instead of BLKNBR
	movw	r17:r16, r25:r24
	clr	r18
	clr	r19			; 32-bit sector number in file or partition

	movw	zh:zl, yh:yl		; Copy ucb pointer (needed in "next-sector")
	ldd	yl, Z+ucb_imgptr+0	; Get pointer to disk image control block
	ldd	yh, Z+ucb_imgptr+1
	ldd	r20, Z+ucb_status	; Get the status
	sbrs	r20, ucb__file		; Is unit attached to a file?
	rjmp	readchk020		; no its a partition
;
;	A file is attached, Y points to the fcb. We put the LBN to the P_Cluster
;	offset of the fcb (file control block) which is then translated to a physical
;	block number by using the fragment list attached to the file control block
;
	std	Y+P_Cluster+0, r16	; Set start LBN for read or write
	std	Y+P_Cluster+1, r17
	std	Y+P_Cluster+2, r18
	std	Y+P_Cluster+3, r19
	call	Logical2Physical	; Convert to PBN (pyhsical block number)
	rjmp	readchk030
	
readchk020:
	ldd	r20, Y+pcb_start+0	; Add start of partition
	add	r16, r20
	ldd	r20, Y+pcb_start+1
	adc	r17, r20
	ldd	r20, Y+pcb_start+2
	adc	r18, r20
	ldd	r20, Y+pcb_start+3
	adc	r19, r20

	ldi	yl, low(pcluster)	; Setup parameter block for general IO
	ldi	yh, high(pcluster)	; 
;	
	std	Y+P_Sector+0, r16	; Set start sector for read or write
	std	Y+P_Sector+1, r17
	std	Y+P_Sector+2, r18
	std	Y+P_Sector+3, r19
;
readchk030:
	ldi	xl, low(pbuffer)	; 
	ldi	xh, high(pbuffer)	; 	
	std	Y+P_Address+0, xl	; Set buffer address for SD-Card block
	std	Y+P_Address+1, xh	; 
	sbi	b_LED
	ldi	r17, led_time
	sts	led_oneshot, r17
	call	SD_CARD_READ		; 
	ldi	xl, low(pbuffer)	; 
	ldi	xh, high(pbuffer)	; 	
	clr	r18
readchk040:
	ld	r16, X+			; Fetch one word from buffer
	ld	r17, X+
	dmawrt	r16, r17		; Write the Word via DMA to PDP-11 Memory
	brcc	readchk050
	clt
	rjmp	readchktmo
readchk050:
	inc	r18
	brne	readchk040


readchk100:
	lds	r16, rdchkaddr+0
	lds	r17, rdchkaddr+1
	lds	r18, rdchkaddr+2
	ori	r16, 0x01		; DMA Read
	andi	r18, 0x3F
	dmaaddr	r16, r17, r18
	ldi	xl, low(pbuffer)	; 
	ldi	xh, high(pbuffer)	; 
	clr	r18
readchk110:
	dmaread	r16, r17
	brcc	readchk120
	set
	rjmp	readchktmo
readchk120:
	ld	r24, X+
	ld	r25, X+
	cp	r24, r16
	cpc	r25, r17
	breq	readchk130
	rcall	readchkmemerr
readchk130:
	inc	r18
	brne	readchk110
	clc
	ret


readchkmemerr:
	sts	pprint+0, r16		; Value 
	sts	pprint+1, r17
	sts	pprint+2, r24		; Buffer
	sts	pprint+3, r25
	sts	pprint+4, r18
	call	print
	.db	"Mismatch at word offset ", 0xF4, ", Buffer:", 0xa0, " PDP-11: ", 0xa2, CR, LF, 0
	ret

readchktmo:
	ldi	r16, 'W'
	brtc	readchktmo010
	ldi	r16, 'R'
readchktmo010:
	sts	pprint+0, r16
	sts	pprint+1, r18
	call	print
	.db	"READ - DMA", 0xc0, " Timeout at word offset: ", 0xF1, CR, LF, 0
	clc
	ret

;--------------------------------------------------------------------------
;
;	load	- load binary to PDP-11 Memory (currently only bootROM)
;
loadboot:
	lds	r16, nbr+0
	lds	r17, nbr+1
	lds	r18, nbr+2
	andi	r16, 0xFE
	andi	r18, 0x3F
	dmaaddr	r16, r17, r18
	ldi	zl, low(2*rom173000)
	ldi	zh, high(2*rom173000)
	clr	r18
loadboot010:
	lpm	r16, Z+
	lpm	r17, Z+
	dmawrt	r16, r17
	brcs	loaderror
	dec	r18
	brne	loadboot010
	clc
	ret

loaderror:
	sts	pprint+0, r18
	sts	pprint+1, zl
	sts	pprint+2, zh
	call	print
	.db	CR, LF, "Error loading bootloader r18: 0x", 0x80, " Pointer 0x"
	.db	0x82, 0x81, CR, LF, 0, 0


	sec
	ret

;
;	The following is a copy of the Plessey MVF11 Multi-Function board.
;	It allows to enter the device mnemonic, unit and CSR address to
;	boot from. Note that all characters must be input in capital letters.
;
;	e.g.
;
;	DD<CR>	Boots from TU-58 Unit0
;	DL<CR>	Boots from the first RL01/02 
;
;	Note that the MSCP (DU) code is missing in the MVF11 ROM and should
;	be added there is enough free space.
;
	align	8
rom165000:
	.dw	0052115,0172522,0000010,0172060,0060003,0046504,0177440,0004000
	.dw	0172126,0000021,0041104,0176700,0004000,0172212,0000071,0042104
	.dw	0176500,0002000,0172264,0000000,0052102,0177500,0000000,0171664
	.dw	0177340,0000000,0000005,0012706,0000500,0010700,0062700,0000024
	.dw	0010037,0000004,0012737,0000340,0000006,0105711,0100376,0000410
	.dw	0010700,0062700,0000130,0010037,0000004,0010401,0105711,0100376
	.dw	0012711,0000004,0012761,0001000,0000002,0012711,0140000,0105711
	.dw	0100376,0012711,0020400,0105711,0100376,0032711,0000001,0001332
	.dw	0010705,0000403,0010705,0000401,0005007,0012711,0000002,0012761
	.dw	0177400,0000002,0012711,0000004,0005061,0000002,0012711,0100000
	.dw	0105711,0100376,0032711,0000001,0001401,0000000,0000165,0000002
	.dw	0000005,0010211,0052711,0060017,0005711,0100772,0006261,0177776
	.dw	0103373,0005161,0000002,0010211,0052711,0060011,0105711,0100376
	.dw	0010705,0000445,0000755,0000005,0010261,0000010,0012711,0000003
	.dw	0105711,0100376,0005711,0100012,0032761,0000040,0000014,0001763
	.dw	0000005,0010261,0000010,0012711,0002003,0000762,0032711,0002000
	.dw	0001402,0052704,0002000,0000413,0000746,0000005,0010213,0012711
	.dw	0000021,0012761,0014000,0000032,0010705,0000402,0000766,0010213
	.dw	0012761,0177000,0000002,0010411,0105711,0100376,0005711,0100035
	.dw	0000165,0000002,0000005,0010605,0012706,0004000,0005213,0005002
	.dw	0004767,0000050,0005013,0005761,0000002,0012702,0004004,0004767
	.dw	0000036,0010002,0004767,0000032,0005002,0105711,0100376,0116122
	.dw	0000002,0022702,0001000,0101371,0010506,0005007,0004717,0004717
	.dw	0004717,0105713,0100376,0110263,0000002,0000302,0000207,0000000
	.dw	0000000,0000000,0000000,0000000,0000000,0000000,0000000,0000000
	.dw	0000000,0000000,0000000,0000000,0000000,0000000,0000000,0000000
	.dw	0000000,0000000,0000000,0000000,0000000,0000000,0000000,0000000
	.dw	0000000,0000000,0000000,0000000,0000000,0000000,0000000,0000000
	.dw	0000000,0000000,0000000,0000000,0000000,0000000,0000000,0000000
	.dw	0000000,0000000,0000000,0000000,0000000,0000000,0000000,0000000
	.dw	0000000,0000000,0000000,0000000,0000000,0000000,0000000,0000000
	.dw	0000000,0000000,0000000,0000000,0000000,0000000,0000000,0000000
rom173000:
	.dw	0000005,0010700,0062700,0000660,0105737,0177564,0100375,0112037
	.dw	0177566,0105710,0001371,0005002,0010705,0000463,0005703,0001361
	.dw	0060002,0000302,0105702,0001770,0010704,0062704,0000606,0062704
	.dw	0000010,0005714,0001746,0100004,0010704,0062704,0171676,0000767
	.dw	0020224,0001365,0012401,0010705,0000434,0010302,0042702,0177770
	.dw	0020027,0000015,0001406,0010705,0000424,0020027,0000015,0001321
	.dw	0010301,0010200,0112405,0001403,0006302,0005305,0001375,0010103
	.dw	0112405,0060503,0012405,0012404,0020103,0001001,0050204,0060705
	.dw	0000115,0005003,0105737,0177560,0100375,0113700,0177562,0110037
	.dw	0177566,0042700,0177600,0020027,0000060,0103412,0020027,0000067
	.dw	0101007,0162700,0000060,0006303,0006303,0006303,0060003,0000752
	.dw	0000165,0000002,0000005,0010705,0000447,0000774,0000005,0052702
	.dw	0000004,0012761,0000013,0000004,0010211,0105711,0100376,0112702
	.dw	0000010,0010211,0105711,0100376,0016100,0000006,0042700,0000177
	.dw	0005200,0010061,0000004,0112702,0000006,0010211,0105711,0100376
	.dw	0011103,0042703,0177776,0001774,0005061,0000004,0012761,0177000
	.dw	0000006,0010705,0000405,0000732,0010213,0012761,0177000,0000002
	.dw	0010411,0105711,0100376,0005711,0100063,0000165,0000002,0000005
	.dw	0010705,0000467,0060704,0005006,0012703,0000001,0010705,0000451
	.dw	0010300,0010705,0000454,0010705,0000450,0010705,0000442,0105714
	.dw	0001014,0005003,0005711,0001776,0100003,0062704,0177775,0000753
	.dw	0105711,0100021,0116123,0000002,0000765,0010705,0000426,0010661
	.dw	0000002,0010705,0000426,0060006,0060006,0122323,0020627,0001000
	.dw	0103002,0024444,0000733,0110200,0006200,0006200,0006200,0006200
	.dw	0005007,0112400,0050200,0010011,0000404,0005000,0152400,0010061
	.dw	0000002,0032711,0100240,0100403,0001774,0000165,0000002,0012704
	.dw	0000212,0052702,0000400,0000673,0000407,0000003,0000407,0040003
	.dw	0000407,0100003,0005015,0000044,0045504,0177404,0003015,0000064
	.dw	0000005,0050104,0176714,0000010,0000064,0000005,0043104,0177460
	.dw	0004002,0000064,0000005,0054104,0177170,0001004,0000236,0000202
	.dw	0054504,0177170,0001004,0000236,0000206,0046104,0174400,0000010
	.dw	0000074,0000014,0000000,0000000,0000000,0000000,0000000,0000000	; No 165000 ROM
;						^^
;	.dw	0000074,0000014,0177777,0000000,0000000,0000000,0000000,0000000
